module RecordPatternDot where

open import Data.Product
open import Relation.Binary.PropositionalEquality

D : {A : Set}(p₁ p₂ : A × A) → proj₁ p₁ ≡ proj₁ p₂ → Set₁
D (x , y) (.x , y′) refl = Set

{-
prf : {A : Set}(p : A × A) → D p p refl ≡ Set
prf p = refl -- D p p refl != Set of type Set₁
-}

E : {A B : Set}(p p' : A × B) → (proj₁ p ≡ proj₁ p') × (proj₂ p ≡ proj₂ p') → Set1
E (x , y) (.x , .y) (refl , refl) = Set

{-
* At the moment I remove dot patterns inside record patterns. This seems
 like a bad idea. Consider the following example:

   D : (p₁ p₂ : A × A) → proj₁ p₁ ≡ proj₁ p₂ → Set₁
   D (x , y) (.x , y′) refl = Set

 The translated clause is not well-typed:

   D p p′ refl = Set

 What should we do about this? We cannot leave the clause as is:
 D p p refl should reduce. On the other hand I don't see any simple
 translation for it. The following code seems too complicated to me:

   D : (p₁ p₂ : B) → proj₁ p₁ ≡ proj₁ p₂ → Set₁
   D p₁ p₂ eq with proj₁ p₁ | proj₂ p₁ | proj₁ p₂ | proj₂ p₂
   D p₁ p₂ refl | x | y | .x | y′ = Set

 Perhaps record patterns containing dot patterns should be rejected.
 However, in this case we should tell Agda's magic algorithm for
 inserting dots to avoid inserting dots inside record patterns whenever
 possible. Is this feasible?

--
/NAD
-}